=== debian/changelog ===
capnproto (0.8.0-2ubuntu2) jammy; urgency=medium

  * d/patches/stringify-most-negative.patch: backport part of upstream commit
    to fix undefined behaviour causing test failures on ppc64el. 

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Wed, 02 Mar 2022 10:46:02 +1300

capnproto (0.8.0-2ubuntu1) jammy; urgency=medium

  * d/p/fix_tls_self_signed_test.patch: add TLS test fix to fix the FTBFS on
    Ubuntu.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Mon, 24 Jan 2022 12:31:53 +0100

capnproto (0.8.0-2) unstable; urgency=medium

  * Upload to unstable (Closes: #1002975)
  * Add debian/gbp.conf for DEP14 layout
  * Refresh tests_fail_with_ipv6.patch for new upstream version
  * Use debhelper-compat 13
  * Bump Standards-Version to 4.6.0

 -- tony mancill <tmancill@debian.org>  Wed, 05 Jan 2022 12:40:57 -0800

capnproto (0.8.0-1) experimental; urgency=medium

  * Imported Upstream version 0.8.0
  * Update packaging for 0.8.0
  * Ignore .la files
  * Drop unnecessary dependency on dh-autoreconf
  * Use canonical URL in Vcs-Git

 -- Tom Lee <debian@tomlee.co>  Sat, 25 Apr 2020 17:33:56 -0700

capnproto (0.7.0-7) unstable; urgency=medium

  * Disable failing test when interface is IPv6-only (Closes: #963855)
    Thank you to Dominic Hargreaves for the bug report and instructions
    for how to reproduce the bug.

 -- tony mancill <tmancill@debian.org>  Mon, 06 Jul 2020 11:52:29 -0700

capnproto (0.7.0-6) unstable; urgency=medium

  * Apply patch for FTBFS on s390x (Closes: #955544)
    Thank you to Michał Sawicz for the bug report and patch.
  * Bump Standards-Version to 4.5.0
  * Specify debhelper compat 12 via debhelper-compat dependency
  * Specify "Rules-Requires-Root: no" in debian/control

 -- tony mancill <tmancill@debian.org>  Thu, 02 Apr 2020 21:15:54 -0700

capnproto (0.7.0-5) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Fix autopkgtest failure with asneeded gcc-9 default flag,
    by moving order of link line (Closes: #939821)

  [ tony mancill ]
  * Add cmake to debian/tests/control
  * Use debhelper 12
  * Add patch for typos in source

 -- tony mancill <tmancill@debian.org>  Tue, 10 Sep 2019 20:29:14 -0700

capnproto (0.7.0-4) unstable; urgency=medium

  [ Tom Lee ]
  * Add a few simple compile + link integration tests

  [ tony mancill ]
  * Update Build-Depends to python3-all (Closes: #936272)
  * Bump Standards-Version to 4.4.0
  * Add myself to Uploaders

 -- tony mancill <tmancill@debian.org>  Wed, 04 Sep 2019 13:12:33 -0700
