=== debian/control ===
Source: capnproto
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Tom Lee <debian@tomlee.co>
Uploaders: tony mancill <tmancill@debian.org>
Build-Depends: cmake,
 debhelper-compat (= 13),
 docbook-xml,
 docbook-xsl,
 dpkg-dev (>= 1.16.1.1),
 gcc (>= 4.7),
 libssl-dev,
 netbase,
 python3-all,
 xsltproc,
 zlib1g-dev
Standards-Version: 4.6.0
Homepage: https://capnproto.org/
Vcs-Git: https://github.com/thomaslee/capnproto-debian.git
Vcs-Browser: https://github.com/thomaslee/capnproto-debian
Rules-Requires-Root: no

Package: libcapnp-0.8.0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Cap'n Proto C++ library
 Similar to Protocol Buffers, Cap'n Proto is an efficient means of
 serializing structured data to be transferred across a network or
 written to disk. Users write a Cap'n Proto definition file that
 drives a code generator, which in turn emits C++ code for encoding &
 decoding messages in the Cap'n Proto format.
 .
 In addition to being extremely fast, Cap'n Proto also smooths over some
 of the rougher aspects of Protocol Buffers & introduces a number of new
 features to boot.
 .
 This package contains the runtime libraries needed for C++ applications.

Package: libcapnp-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, libcapnp-0.8.0 (= ${binary:Version})
Description: Cap'n Proto C++ library (development files)
 Similar to Protocol Buffers, Cap'n Proto is an efficient means of
 serializing structured data to be transferred across a network or
 written to disk. Users write a Cap'n Proto definition file that
 drives a code generator, which in turn emits C++ code for encoding &
 decoding messages in the Cap'n Proto format.
 .
 In addition to being extremely fast, Cap'n Proto also smooths over some
 of the rougher aspects of Protocol Buffers & introduces a number of new
 features to boot.
 .
 This package contains the headers and static libraries needed for writing
 C++ applications.

Package: capnproto
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${misc:Depends},
 libcapnp-0.8.0 (= ${binary:Version})
Description: tool for working with the Cap'n Proto data interchange format
 Similar to Protocol Buffers, Cap'n Proto is an efficient means of
 serializing structured data to be transferred across a network or
 written to disk. Users write a Cap'n Proto definition file that
 drives a code generator, which in turn emits C++ code for encoding &
 decoding messages in the Cap'n Proto format.
 .
 In addition to being extremely fast, Cap'n Proto also smooths over some
 of the rougher aspects of Protocol Buffers & introduces a number of new
 features to boot.
 .
 This package contains a small suite of tools for developing & maintaining
 your Cap'n Proto schema files, including a code generator for compiling
 your schema files to supported languages.
