=== debian/tests/control ===
Tests: cli-tests, build-tests
Depends: @, shunit2, bash, g++, pkg-config, cmake
