=== debian/changelog ===
capnproto (0.9.2-3) unstable; urgency=medium

  * Fix FTBFS with GCC-13 (Closes: #1037598)
  * Freshen years in debian/copyright
  * Bump Standards-Version to 4.6.2 (no changes)

 -- tony mancill <tmancill@debian.org>  Sat, 15 Jul 2023 12:36:09 -0700

capnproto (0.9.2-2) unstable; urgency=medium

  * Upload to unstable
    Transition bug #1025449

 -- tony mancill <tmancill@debian.org>  Sun, 04 Dec 2022 13:18:59 -0800

capnproto (0.9.2-1) experimental; urgency=medium

  [ Tom Lee ]
  * Upload to experimental
  * Imported Upstream version 0.9.2 for CVE-2022-46149
  * Update packaging for 0.9.2

  [ tony mancill ]
  * Tweak lintian overrides
  * Bump Standards-Version to 4.6.1

 -- Tom Lee <debian@tomlee.co>  Wed, 30 Nov 2022 21:26:40 -0800

capnproto (0.9.1-4) unstable; urgency=medium

  * Fix OpenSSL 3.0 FTBFS (Closes: #1006299)

 -- Tom Lee <debian@tomlee.co>  Sat, 05 Mar 2022 15:58:08 -0800

capnproto (0.9.1-3) unstable; urgency=medium

  * Upload to unstable
    Transition bug #1006599

 -- tony mancill <tmancill@debian.org>  Fri, 04 Mar 2022 20:58:32 -0800

capnproto (0.8.0-3) unstable; urgency=medium

  * Add serde-tests autopkgtest
  * Add files for CI automation (GitHub Actions)
  * Update debian/copyright (Closes: #1005011)

 -- Tom Lee <debian@tomlee.co>  Thu, 17 Feb 2022 08:41:58 -0800

capnproto (0.9.1-2) experimental; urgency=medium

  * Add libatomic check for armel (Closes: #1005066)
  * Add tests for atomics via kj::AtomicRefcounted
  * Trap EXIT in build-tests
  * Update debian/copyright (Closes: #1005011)

 -- Tom Lee <debian@tomlee.co>  Fri, 11 Feb 2022 23:13:08 -0800

capnproto (0.9.1-1) experimental; urgency=medium

  * Add serde-tests autopkgtest
  * Add files for CI automation (GitHub Actions)
  * Imported Upstream version 0.9.1
  * Update packaging for 0.9.1
  * libcapnp-dev now has a hard dependency on libssl-dev

 -- Tom Lee <debian@tomlee.co>  Mon, 10 Jan 2022 12:08:47 -0800
