=== debian/control ===
--- 
+++ 
@@ -1,27 +1,25 @@
 Source: capnproto
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Tom Lee <debian@tomlee.co>
+Maintainer: Tom Lee <debian@tomlee.co>
 Uploaders: tony mancill <tmancill@debian.org>
 Build-Depends: cmake,
  debhelper-compat (= 13),
  docbook-xml,
  docbook-xsl,
- dpkg-dev (>= 1.16.1.1),
- gcc (>= 4.7),
  libssl-dev,
  netbase,
  python3-all,
  xsltproc,
- zlib1g-dev
-Standards-Version: 4.6.0
+ zlib1g-dev,
+ ca-certificates
+Standards-Version: 4.6.2
 Homepage: https://capnproto.org/
-Vcs-Git: https://github.com/thomaslee/capnproto-debian.git
+Vcs-Git: https://github.com/thomaslee/capnproto-debian.git -b debian/master
 Vcs-Browser: https://github.com/thomaslee/capnproto-debian
 Rules-Requires-Root: no
 
-Package: libcapnp-0.8.0
+Package: libcapnp-0.9.2
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -43,7 +41,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: ${misc:Depends}, libcapnp-0.8.0 (= ${binary:Version})
+Depends: ${misc:Depends}, libcapnp-0.9.2 (= ${binary:Version}), libssl-dev
 Description: Cap'n Proto C++ library (development files)
  Similar to Protocol Buffers, Cap'n Proto is an efficient means of
  serializing structured data to be transferred across a network or
@@ -62,7 +60,7 @@
 Architecture: any
 Multi-Arch: foreign
 Depends: ${shlibs:Depends}, ${misc:Depends},
- libcapnp-0.8.0 (= ${binary:Version})
+ libcapnp-0.9.2 (= ${binary:Version})
 Description: tool for working with the Cap'n Proto data interchange format
  Similar to Protocol Buffers, Cap'n Proto is an efficient means of
  serializing structured data to be transferred across a network or
